// Copyright 2011, 2020 Paul Milenkovic, 118 Shiloh Dr., Madison, WI 53705 U.S.A.
// Free software: Permission granted to use, copy, excerpt or share this
// source code and derived executables provided that this notice is maintained.  

import net.cspeech.DSP.*;

public class LP1st extends InPlace implements SISOFilter {
    
    private double a1, b0, b1, x1, y1;
    
    protected void Init(double sample_ms) {
        super.Init(sample_ms);
        x1 = 0.0; y1 = 0.0;
    }

    public final double gety0(double x0) {
        double y0 = a1*y1 + b0*x0 - b1*x1;
        x1 = x0;
        y1 = y0;            
        return y0;        
    }
    
    protected void Apply(float[] sig) {
        for (int n = 0; n < sig.length; n++) 
            sig[n] = (float) gety0(sig[n]);
    }

    public void setParams(double[] params) {
        if (params != null) {
            if (params.length > 0) a1 = params[0];
            if (params.length > 1) b0 = params[1];
            if (params.length > 2) b1 = params[2];
        }
    }
}
