// Copyright 2011 Paul Milenkovic, 118 Shiloh Dr., Madison, WI 53705 U.S.A.
// Free software: Permission granted to use, copy, excerpt or share this
// source code and derived executables provided that this notice is maintained.  

import net.cspeech.DSP.*;

public class RandomImpulse extends InPlace implements SISOFilter {
    
    private double amp = 1.0;
    private int N = 10, kN;
    
    protected void Init(double sample_ms) {
        super.Init(sample_ms);
        kN = 0;
    }

    protected void Apply(float[] sig) {
        for (int n = 0; n < sig.length; n++) { 
            if (kN == 0) {
            	if (Math.random() > .5) sig[n] += amp; else sig[n] -= amp;
            }
            kN++;
            if (kN >= N) kN = 0;
        }
    }

    public void setParams(double[] params) {
        if (params != null) {
            if (params.length > 0) N = (int) params[0];
            if (params.length > 1) amp = params[1];
        }
    }
}
