public class EyePlot extends NumericOut {
	
    private WaveMonitorJ wave_mon = null; 
    private int N = 50, kN;
    private double[] uh = new double[N];
    private double[] ul = new double[N];
    private double[] lh = new double[N];
    private double[] ll = new double[N];
    private double[] tn = new double[N];
    
    public void dispose() {
        if (wave_mon != null) {wave_mon.dispose(); wave_mon = null;}}
        
    public void setWaveMonitor(WaveMonitorJ wm) {
    	dispose(); wave_mon = wm; wave_mon.setNotify(this);}
    
    public void onNewWave(int msamp, double ms) {
    	for (int i = 0; i < N; i++) {
    		tn[i] = i*ms;
    		uh[i] = 0; ul[i] = 20; lh[i] = -20; ll[i] = 0;
    	}
    	kN = 0;
    }
    
    public void onCursors(int iscn, int fscn, int icur, int fcur, int pcur) {
    	println("Eye plot");
    	wave_mon.transmitByEvent(icur, fcur, 1024);
    }

    public void onTransmit(float[] s, boolean end_of_src) {
    	for (int n = 0; n < s.length; n++) {
    		if (kN >= N) kN -= N;
    		if (s[n] > uh[kN]) uh[kN] = s[n];
    		if (s[n] > 0 && s[n] < ul[kN]) ul[kN] = s[n];
    		if (s[n] < 0 && s[n] > lh[kN]) lh[kN] = s[n];
    		if (s[n] < ll[kN]) ll[kN] = s[n];
    		kN++;
    	}
    	if (end_of_src) {
    		for (int i = 0; i < N; i++) {
    			print(tn[i]); print();
    			print(ll[i]); print();
    			print(lh[i]); print();
    			print(ul[i]); print();
    			print(uh[i]); println();
    		}
    		dispose();
    	}
    }

}
