import java.text.DecimalFormat;

// Copyright 2008 Paul Milenkovic, 118 Shiloh Dr., Madison, WI 53705 U.S.A.
// Free software: Permission granted to use, copy, excerpt or share this
// source code and derived executables provided that this notice is maintained.  

public class NumericOut {
    
    private DecimalFormat fmt = new DecimalFormat("0.000000000");
    private char sep = '\t';

    public void print() {System.out.print(sep);}
    
    public void println() {System.out.println();}
    
    public void print(String str) {System.out.print(str);}
    
    public void println(String str) {print(str); println();}
    
    public void print(double d) {print(fmt.format(d));}
    
    public void printtb(double d) {print(fmt.format(d)); print();}
    
    public void println(double d) {print(d); println();}
    
    public void print(double[] da) {
    	if (da.length >= 1) print(da[0]);
    	for (int i = 1; i < da.length; i++) {print(); print(da[i]);}
    }
    
    public void printtb(double[] da) {print(da); print();}

    public void println(double[] da) {print(da); println();}
}
