﻿// Copyright 2011, 2022 Paul Milenkovic
import javax.swing.*;

//  The January 2022 update allows removing ClassLoad.java from runjava
public class TF32JMod extends TF32J {  
    	
    protected TF32JMod(String[] appArgs, boolean main_window) {
    	super(appArgs, main_window);}
    
    public TF32JMod(String[] appArgs) {this(appArgs, false);}

    public TF32JMod() {this(null);}
    
 // Called from java command line    
    public static void main(String[] args) {
    	new TF32JMod(new String[] {"sine1k.voc"}, true);}
    
	private JMenuItem menuItem(JMenu filter_menu, String menu_entry,
			java.awt.event.ActionListener action) 
	{
        JMenuItem menuItem = new JMenuItem(menu_entry);
        menuItem.addActionListener(action);
        filter_menu.add(menuItem);
        return menuItem;
	}
		
    protected void extendMenu(JMenuBar menu_bar, JMenu menu) {
    	menu.addSeparator();
    	
    	// The parameter
    	//     e->(new EyePlot().setWaveMonitor(createWaveMonitor()) 
    	// supplied below in a call to menuItem() is a lambda expression.
    	// This is an anonymous function (one with no name).
    	//
    	// This function, in turn, will specify the action to take place when
    	// a menu selection is made.  The action variable is expected to be 
    	// an object implementing the ActionListener interface and in turn
    	// having an actionPerformed(ActionEvent e) method.  In Java, the lambda 
    	// used in this way becomes a concise expression of such an object.
    	//
    	// When lambda is supplied as a method argument as seen here, e in
    	//     e-> 
    	// is inferred to be type ActionEvent.  The statement (no final semicolon)
    	//     (new EyePlot()).setWaveMonitor(createWaveMonitor())
    	// becomes the body of actionPerformed(e). Argument e is not needed 
    	// in the statement of the lambda in this particular example, but specifying
    	// it anyway allows the lambda to be referenced by type ActionListener.
    	//
    	// See the link TF32J javadocs at 
    	//     https://ubeam.engr.wisc.edu/AnalogModulation.html
    	// for information on the TF32J.invoke() method called in the
    	// remaining lambda expressions below.
    	
    	menuItem(menu, "Output eye plot", 
    		e->(new EyePlot()).setWaveMonitor(createWaveMonitor()));
        
    	menuItem(menu, "USB_modulate", e->invoke("ModDemod", "modSSB"));
        menuItem(menu, "USB demodulate", e->invoke("ModDemod", "demodSSB"));
        
        menuItem(menu, "DSB modulate", e->invoke("ModDemod", "modDSB"));        
        menuItem(menu, "DSB demodulate", e->invoke("ModDemod", "demodDSB"));
        
        menuItem(menu, "FM modulate", e->invoke("ModDemod", "modFM"));        
        menuItem(menu, "FM demodulate", e->invoke("ModDemod", "demodFM"));
        menuItem(menu, "FM PLL", e->invoke("ModDemod", "demodFMPLL"));
        
        addButton(new JButton("Open")).addActionListener(e->openWaveDlg());
        addButton(new JButton("Zero")).addActionListener(e->zeroWave());
        
     // Configures the time-slice spectrum analyzer   
        setSpecPreem(false);
    }
    
}
